#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct
	{
		double thred;
		double start;
		double  stop;
	} metad;
metad   * array;
metad     procs;

int main(int argc, char **argv)
{
  int rank, size, nopr, i, j, k;
  double sinsin, startime, stoptime;
  long int li, Nruntime;

  nopr = 1; Nruntime=9999999;
  if (argc>0) nopr = atoi(argv[1]); // number of processes

// init MPI
  
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);

// print inputs & take time in mother process
  if (rank==0) 
  {
	startime = MPI_Wtime();
  	printf("input nopr=%d \n",nopr);
	array = malloc(nopr*sizeof(metad));
	for (i=0; i<nopr; i++)
	{
		array[i].thred=0;
		array[i].start=0;
		array[i].stop =0;
	}
  }

  MPI_Scatter(&array[rank],3,MPI_DOUBLE,&procs,3,MPI_DOUBLE,0,MPI_COMM_WORLD);

// run processes inner loops

  procs.start = MPI_Wtime();
	  for (j=0; j<16/nopr ; j++)
	  for (k=0; k<Nruntime; k++)
		{
			sinsin=sin(k);
		}
  procs.thred= rank;
  procs.stop = MPI_Wtime();

  MPI_Gather(&procs,3,MPI_DOUBLE,array,3,MPI_DOUBLE,0,MPI_COMM_WORLD);

// print process runtime vector in mother process
  if(rank==0)
  {
	for (i=0; i<nopr; i++)
		printf("Iter %d process %f Runtime %f \n",
		i, array[i].thred, array[i].stop - array[i].start);
// take time & print walltime
	stoptime = MPI_Wtime();
	printf("time = %f \n",stoptime-startime);
  }

// close MPI 
  MPI_Finalize();

  return 0;
}

