#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct
	{
		double thred;
		double start;
		double  stop;
	} metad;
metad   * array;
metad     procs;

int main(int argc, char **argv)
{
  int rank,size,noel,nopr,ntrd,i,j,k;
  double  sinsin, startime, stoptime;
  long int li, Nruntime;

  Nruntime=9999999;
  nopr = 1; ntrd = 1; noel = 1; 
  if (argc>1) nopr = atoi(argv[1]); // number of processes
  if (argc>2) ntrd = atoi(argv[2]); // number of threads
  if (argc>3) noel = atoi(argv[3]); // number of base iteration

// init MPI
  
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);

// print inputs & take time in mother process
  if (rank==0) 
  {
	startime = MPI_Wtime();
  	printf("input nopr=%d ntrd=%d noel=%d \n",nopr,ntrd,noel);
	array = malloc(nopr*sizeof(metad));
	for (i=0; i<nopr; i++)
	{
		array[i].thred=0;
		array[i].start=0;
		array[i].stop =0;
	}
  }

  MPI_Scatter(&array[rank],3,MPI_DOUBLE,&procs,3,MPI_DOUBLE,0,MPI_COMM_WORLD);

// run processes inner loops

  procs.start = MPI_Wtime();

#pragma omp parallel for num_threads(ntrd) private(j, k, sinsin)

  for (j=0; j<16*noel/nopr; j++)
     {
  	for (k=0; k<Nruntime; k++)
	{
		sinsin=sin(k);
	}
     }

// end of #pragma

  procs.thred= rank;
  procs.stop = MPI_Wtime();

  MPI_Gather(&procs,3,MPI_DOUBLE,array,3,MPI_DOUBLE,0,MPI_COMM_WORLD);

// print process runtime vector in mother process
  if(rank==0)
  {
	for (i=0; i<nopr; i++)
		printf("Iter %d process %f Runtime %f \n",
		i, array[i].thred, array[i].stop - array[i].start);
// take time & print walltime
	stoptime = MPI_Wtime();
	printf("time = %f \n",stoptime-startime);
  }

// close MPI 
  MPI_Finalize();

  return 0;
}

