#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main (int argc, char *argv[]) 
{
	typedef struct
		{
			long int thred;
			double   start;
			double   stop;
		} metad;
	metad   * array;

	long int i,j,k, Nthread, Niter, Nruntime;
	double time_start, time_stop, seconds, sinsin;

	time_start=omp_get_wtime();

	Nthread=1; Niter=16; Nruntime=9999999;
	if (argc>1) Nthread=atoi(argv[1]);
	if (argc>2) Niter  =atoi(argv[2]);

	array = malloc(Niter*sizeof(metad));

	#pragma omp parallel for num_threads(Nthread) private(j,k,sinsin)

	for (i=0; i<Niter; i++)
	{
		array[i].start = omp_get_wtime();

		for (j=0; j<16/Niter; j++)
		for (k=0; k<Nruntime  ; k++)
		{
			sinsin=sin(k);
		}
		array[i].thred= omp_get_thread_num();
		array[i].stop = omp_get_wtime();
	}

	time_stop=omp_get_wtime();
	seconds=time_stop - time_start;
	printf("walltime %f \n", seconds);

	for (i=0; i<Niter; i++)
		printf("%ld Thread %ld Start %f Stop %f Run %f \n",i,array[i].thred,
			array[i].start, array[i].stop, array[i].stop - array[i].start);

	return 0;
}
